#!/bin/bash

change_password () {
  local PASSWORD="$(whiptail --title "Change Password" --passwordbox "Enter new password for user \"pi\"" 10 50 3>&1 1>&2 2>&3)"
  if [[ $? != 0 ]]; then return 1; fi
  if [[ "$PASSWORD" == "raspberry" ]]; then
    whiptail --title "Change Password" --msgbox "That password sucks. Please use a different one :)" 10 50
    change_password
    return 0
  fi
  if [[ "$(whiptail --passwordbox "Confirm new password for user \"pi\"" 10 50 3>&1 1>&2 2>&3)" == "$PASSWORD" ]]; then
    if [[ $? != 0 ]]; then return 1; fi 
    echo -e "$PASSWORD\n$PASSWORD" | passwd pi
  else
    whiptail --title "Change Password" --msgbox "Passwords did not match!" 10 50
    change_password
    return 0
  fi
  local OCTOPASS="$(cat /dev/urandom | tr -dc _A-Z-a-z-0-9 | head -c20)"
  echo -e "$OCTOPASS\n$OCTOPASS" | passwd octoprint
  local ROOTPASS="$(cat /dev/urandom | tr -dc _A-Z-a-z-0-9 | head -c20)"
  echo -e "$ROOTPASS\n$ROOTPASS" | passwd root
  unset OCTOPASS 
  unset ROOTPASS
  unset PASSWORD
}

service_select () {
  local SERVICE_MENU=$(whiptail --title "Select services" --checklist "Enable/disable services" 0 0 0 \
    "OctoPrint" "" ON \
    "GUI" "" ON \
    "SSH" "" OFF 3>&1 1>&2 2>&3)
  SERVICE_MENU=($SERVICE_MENU)

  for i in "${SERVICE_MENU[@]}"; do
    case $i in
      "OctoPrint") systemctl enable octoprint ;;
      "GUI") systemctl set-default graphical.target ;;
      "SSH")
        ssh-keygen -A
        systemctl enable sshd ;;
    esac
  done
}

nmtui
configure_password || exit 1
service_select || exit 1
systemctl disable first-time || exit 1
rm /etc/systemd/system/first-time.service
reboot

